/*
 * Created on 27.06.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package gui;

import io.FileToString;
import io.FileUtils;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.SQLException;
import java.util.Properties;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.window.ApplicationWindow;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;

import shell.ShellUtils;
import sqlplus.OracleExportFileGenerator;

/**
 * @author Dietmar Aust
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class OracleExportTool extends ApplicationWindow {

	private Text txtNumberFormat;
	private Text txtTNS;

	private Text txtOutput;

	private Action actionGenerateScript;

	private Text txtDateFormat;

	private Combo cbxSeparator;

	private Text txtDynamicSpoolFileName;

	private Text txtStaticSpoolFileName;

	private Text txtScriptFileName;

	private Text txtSQL;

	private Text txtJdbcUrl;

	private Text txtPassword;

	private Text txtUser;

	private Action actionExit;

	private boolean useStaticFilename = true;

	private boolean includeHeader = true;
	private boolean maskQuote = true;

	private static String propertiesFilename = "";

	private void setDefaults(String propertiesFilename) {
		Properties props = new Properties();

		if (!propertiesFilename.equals("")) {
			try {
				props.load(new FileInputStream(propertiesFilename));
				txtUser
						.setText((String) (props.get("connect.user") == null ? ""
								: props.get("connect.user")));
				txtPassword
						.setText((String) (props.get("connect.password") == null ? ""
								: props.get("connect.password")));
				txtJdbcUrl
						.setText((String) (props.get("connect.jdbcUrl") == null ? ""
								: props.get("connect.jdbcUrl")));
				txtTNS.setText((String) (props.get("connect.tns") == null ? ""
						: props.get("connect.tns")));
				txtSQL.setText((String) (props.get("sql.text") == null ? ""
						: props.get("sql.text")));

				txtScriptFileName.setText((String) (props
						.get("options.scriptFilename") == null ? "" : props
						.get("options.scriptFilename")));
				txtStaticSpoolFileName.setText((String) (props
						.get("options.staticSpoolFilename") == null ? ""
						: props.get("options.staticSpoolFilename")));
				txtDynamicSpoolFileName.setText((String) (props
						.get("options.dynamicSpoolFilename") == null ? ""
						: props.get("options.dynamicSpoolFilename")));
				//txtSQL.setText((String)
				// (props.get("options.isStatic")==null?"":props.get("options.isStatic")));
				String sepChar = (String) (props.get("options.separatorChar") == null ? ""
						: props.get("options.separatorChar"));
				cbxSeparator.select(Integer.parseInt(sepChar));
				txtDateFormat
				.setText((String) (props.get("options.dateFormat") == null ? ""
						: props.get("options.dateFormat")));
				txtNumberFormat
				.setText((String) (props.get("options.numberFormat") == null ? ""
						: props.get("options.numberFormat")));
				//txtSQL.setText((String)
				// (props.get("options.includeHeader")==null?"":props.get("options.includeHeader")));

				MessageDialog.openInformation(getShell(), "OracleExportTool",
						"Lade Parameter aus Datei: " + propertiesFilename);
			} catch (FileNotFoundException e) {
				MessageDialog.openError(getShell(), "OracleExportTool",
						"Properties file:" + propertiesFilename
								+ " kann nicht geffnet werden!");
			} catch (Exception e) {
				MessageDialog.openError(getShell(), "OracleExportTool",
						"Properties file Lesefehler:" + propertiesFilename
								+ " : " + e.getMessage());
			}
		}

	}

	public OracleExportTool() {
		super(null);
		createActions();
		addToolBar(SWT.NONE);
		addMenuBar();

	}

	protected Control createContents(Composite parent) {
		Composite container = new Composite(parent, SWT.NONE);
		{
			final Button btnExit = new Button(container, SWT.NONE);
			btnExit.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					actionExit.run();
				}
			});
			btnExit.setBounds(400, 325, 100, 25);
			btnExit.setText("Exit");
		}
		{
			final TabFolder tabFolder = new TabFolder(container, SWT.NONE);
			tabFolder.setBounds(10, 10, 490, 305);
			{
				final TabItem tabItemConnection = new TabItem(tabFolder,
						SWT.NONE);
				tabItemConnection.setText("Datenbankverbindung");
				{
					final Composite composite = new Composite(tabFolder,
							SWT.NONE);
					tabItemConnection.setControl(composite);
					{
						final Group group = new Group(composite, SWT.NONE);
						group.setBounds(5, 5, 465, 160);
						group.setText("Datenbankverbindung");
						{
							final Label lblUser = new Label(group, SWT.NONE);
							lblUser.setBounds(15, 25, 65, 15);
							lblUser.setText("User:");
						}
						{
							final Label lblPassword = new Label(group, SWT.NONE);
							lblPassword.setBounds(15, 50, 70, 15);
							lblPassword.setText("Passwort:");
						}
						{
							final Label lblJdbcUrl = new Label(group, SWT.NONE);
							lblJdbcUrl.setBounds(15, 80, 70, 15);
							lblJdbcUrl.setText("JDBC-Url:");
						}
						{
							txtUser = new Text(group, SWT.BORDER);
							txtUser.setText("olga");
							txtUser.setBounds(95, 20, 225, 20);
						}
						{
							txtPassword = new Text(group, SWT.BORDER
									| SWT.PASSWORD);
							txtPassword.setText("olga");
							txtPassword.setBounds(95, 50, 225, 20);
						}
						{
							txtJdbcUrl = new Text(group, SWT.BORDER);
							txtJdbcUrl.setText("localhost:1521:olga");
							txtJdbcUrl.setBounds(95, 80, 160, 20);
						}
						{
							final Label label = new Label(group, SWT.NONE);
							label.setBounds(15, 110, 70, 15);
							label.setText("TNS-Connect:");
						}
						{
							txtTNS = new Text(group, SWT.BORDER);
							txtTNS.setBounds(95, 110, 130, 20);
							txtTNS.setText("olga");
						}
						{
							final Label lblTNSSample = new Label(group,
									SWT.NONE);
							lblTNSSample.setBounds(235, 110, 210, 15);
							lblTNSSample
									.setText("(Eintrag in der tnsnames.ora, z.B.  prlg1)");
						}
						{
							final Label lblJdbcUrlSample = new Label(group,
									SWT.NONE);
							lblJdbcUrlSample.setBounds(260, 80, 185, 15);
							lblJdbcUrlSample.setText("(Host:Port:SID)");
						}
					}
				}
			}
			{
				final TabItem tabItemSQL = new TabItem(tabFolder, SWT.NONE);
				tabItemSQL.setText("SQL");
				{
					final Composite composite = new Composite(tabFolder,
							SWT.NONE);
					tabItemSQL.setControl(composite);
					{
						final Group grpSQL = new Group(composite, SWT.NONE);
						grpSQL
								.setText("SQL-Statement, welches exportiert wird");
						grpSQL.setBounds(5, 5, 465, 265);
						{
							txtSQL = new Text(grpSQL, SWT.BORDER | SWT.H_SCROLL
									| SWT.MULTI | SWT.V_SCROLL);
							txtSQL
									.setText("select user, rownum, sysdate, r.* from ref_codes r");
							txtSQL.setBounds(10, 20, 445, 235);
						}
					}
				}
			}
			{
				final TabItem tabItemOptions = new TabItem(tabFolder, SWT.NONE);
				tabItemOptions.setText("Optionen");
				{
					final Composite composite = new Composite(tabFolder,
							SWT.NONE);
					tabItemOptions.setControl(composite);
					{
						final Group grpScriptFile = new Group(composite,
								SWT.NONE);
						grpScriptFile.setText("Skript-Datei");
						grpScriptFile.setBounds(5, 5, 470, 60);
						{
							final Label lblScriptFileName = new Label(
									grpScriptFile, SWT.NONE);
							lblScriptFileName.setBounds(10, 25, 60, 15);
							lblScriptFileName.setText("Dateiname:");
						}
						{
							txtScriptFileName = new Text(grpScriptFile,
									SWT.BORDER);
							txtScriptFileName.setText("c:\\cvsQuery.sql");
							txtScriptFileName.setBounds(80, 20, 340, 20);
						}
					}
					{
						final Group groupSpoolFile = new Group(composite,
								SWT.NONE);
						groupSpoolFile.setBounds(5, 70, 470, 85);
						groupSpoolFile.setText("Ausgabedatei");
						{
							txtStaticSpoolFileName = new Text(groupSpoolFile,
									SWT.BORDER);
							txtStaticSpoolFileName
									.setText("c:\\queryOutput.csv");
							txtStaticSpoolFileName.setBounds(155, 20, 265, 20);
						}
						{
							final Button radioStaticFileName = new Button(
									groupSpoolFile, SWT.RADIO);
							radioStaticFileName
									.addSelectionListener(new SelectionAdapter() {
										public void widgetSelected(
												SelectionEvent e) {
											useStaticFilename = true;
										}
									});
							radioStaticFileName.setSelection(true);
							radioStaticFileName.setBounds(10, 20, 135, 25);
							radioStaticFileName
									.setText("statischer Dateiname:");
						}
						{
							final Button radioDynamicFileName = new Button(
									groupSpoolFile, SWT.RADIO);
							radioDynamicFileName
									.addSelectionListener(new SelectionAdapter() {
										public void widgetSelected(
												SelectionEvent e) {
											useStaticFilename = false;
										}
									});
							radioDynamicFileName.setBounds(10, 50, 135, 25);
							radioDynamicFileName
									.setText("dynamischer Dateiname:");
						}
						{
							txtDynamicSpoolFileName = new Text(groupSpoolFile,
									SWT.BORDER);
							txtDynamicSpoolFileName
									.setText("select 'out_'||to_char(sysdate,'YYMMDD')||'.csv' filename from dual;");
							txtDynamicSpoolFileName.setBounds(155, 50, 265, 20);
						}
					}
					{
						final Group grpFormat = new Group(composite, SWT.NONE);
						grpFormat.setText("Ausgabeformat");
						grpFormat.setBounds(5, 165, 470, 100);
						{
							final Label lblSeparator = new Label(grpFormat,
									SWT.NONE);
							lblSeparator.setBounds(10, 20, 80, 15);
							lblSeparator.setText("Trennzeichen:");
						}
						{
							cbxSeparator = new Combo(grpFormat, SWT.NONE);
							cbxSeparator.setItems(new String[] { ",", ";",
									"<TAB>" });
							cbxSeparator.select(1);
							cbxSeparator.setBounds(100, 15, 100, 25);
						}
						{
							final Label lblDateFormat = new Label(grpFormat,
									SWT.NONE);
							lblDateFormat.setBounds(10, 45, 80, 15);
							lblDateFormat.setText("Datumsformat:");
						}
						{
							txtDateFormat = new Text(grpFormat, SWT.BORDER);
							txtDateFormat.setText("DD.MM.YYYY");
							txtDateFormat.setBounds(100, 45, 135, 20);
						}
						{
							final Label lblDateFormatSample = new Label(
									grpFormat, SWT.NONE);
							lblDateFormatSample.setBounds(250, 45, 175, 15);
							lblDateFormatSample
									.setText("(z.B.: DD.MM.YYYY HH24:MI:SS)");
						}
						{
							final Button chkIncludeHeader = new Button(
									grpFormat, SWT.CHECK);
							chkIncludeHeader
									.addSelectionListener(new SelectionAdapter() {
										public void widgetSelected(
												SelectionEvent e) {

											includeHeader = chkIncludeHeader
													.getSelection();
										}
									});
							chkIncludeHeader.setSelection(true);
							chkIncludeHeader.setBounds(250, 15, 215, 25);
							chkIncludeHeader
									.setText("Spaltennamen in der ersten Zeile?");
						}
						{
							final Label lblNumberFormat = new Label(grpFormat, SWT.NONE);
							lblNumberFormat.setBounds(10, 70, 80, 15);
							lblNumberFormat.setText("Zahlenformat:");
						}
						{
							txtNumberFormat = new Text(grpFormat, SWT.BORDER);
							txtNumberFormat.setBounds(100, 70, 135, 20);
						}
						{
							final Button chkMaskQuote = new Button(grpFormat, SWT.CHECK);
							chkMaskQuote.setSelection(true);
							chkMaskQuote.addSelectionListener(new SelectionAdapter() {
								public void widgetSelected(SelectionEvent e) {
									maskQuote = chkMaskQuote.getSelection();
								}
							});
							chkMaskQuote.setBounds(250, 65, 210, 25);
							chkMaskQuote.setText("Anfhrungszeichen maskieren (\" => \"\")?");
						}
					}
				}
			}
			{
				final TabItem tabItemOutput = new TabItem(tabFolder, SWT.NONE);
				tabItemOutput.setText("Ausgabe");
				{
					final Composite composite = new Composite(tabFolder,
							SWT.NONE);
					tabItemOutput.setControl(composite);
					{
						final Group grpOutput = new Group(composite, SWT.NONE);
						grpOutput.setText("generiertes Skript");
						grpOutput.setBounds(5, 5, 470, 265);
						{
							txtOutput = new Text(grpOutput, SWT.BORDER
									| SWT.H_SCROLL | SWT.MULTI | SWT.V_SCROLL);
							txtOutput.setBounds(10, 20, 450, 205);
						}
						{
							final Button btnExecute = new Button(grpOutput,
									SWT.NONE);
							btnExecute
									.addSelectionListener(new SelectionAdapter() {
										public void widgetSelected(
												SelectionEvent e) {

											if (FileUtils
													.fileExists(txtScriptFileName
															.getText())) {
												Cursor cursor = null;
												try {
													// generate calling sqlplus script
													OracleExportFileGenerator gen = new OracleExportFileGenerator();
													String exeSqlFilename = "c:\\oracleExportTool.sql";
													gen.generateExecuteSQLScript(exeSqlFilename, txtScriptFileName.getText());
													
													//sqlplus
													// hr/password@sales-server:1521/sales.us.acme.com
													String cmd = "sqlplus "
															+ txtUser.getText()
															+ "/"
															+ txtPassword
																	.getText()
															+ "@"
															+ txtTNS.getText()
															+ " @"
															+ exeSqlFilename;
													MessageDialog
															.openInformation(
																	getShell(),
																	"Skript ausfhren",
																	"Command: sqlplus "
																			+ txtUser
																					.getText()
																			+ "@"
																			+ txtTNS
																					.getText()
																			+ " @"
																			+ txtScriptFileName
																					.getText());
													GuiUtils
															.showWaitCursor(getShell());
													ShellUtils
															.ExecuteCommand(cmd);
													GuiUtils.hideWaitCursor();
													MessageDialog
															.openInformation(
																	getShell(),
																	"Skript ausfhren",
																	"Success!");
												} catch (IOException e1) {
													if (cursor != null)
														GuiUtils
																.hideWaitCursor();
													MessageDialog.openError(
															getShell(),
															"Error",
															e1.getMessage());
												}

											} else {
												MessageDialog
														.openError(
																getShell(),
																"Error",
																"Das Skript "
																		+ txtScriptFileName
																				.getText()
																		+ " existiert noch nicht, bitte zuerst 'Skript erzeugen'!");
											}
										}
									});
							btnExecute.setBounds(360, 230, 100, 25);
							btnExecute.setText("Skript ausfhren");
						}
					}
				}
			}
		}
		{
			final Button btnCreateScript = new Button(container, SWT.NONE);
			btnCreateScript.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					actionGenerateScript.run();
				}
			});
			btnCreateScript.setBounds(285, 325, 100, 25);
			btnCreateScript.setText("Skript erzeugen");
		}
		//
		return container;
	}

	private void createActions() {
		{
			actionExit = new Action() {
				public void run() {
					System.exit(0);
				}
			};
			actionExit.setText("Exit");
		}
		{
			actionGenerateScript = new Action() {
				public void run() {
					// delete output window first
					txtOutput.setText("");
					OracleExportFileGenerator gen = new OracleExportFileGenerator();
					try {
						String fileName = "";
						if (useStaticFilename == true) {
							fileName = txtStaticSpoolFileName.getText();
						} else {
							fileName = txtDynamicSpoolFileName.getText();
						}
						GuiUtils.showWaitCursor(getShell());

						gen.generateScript(txtUser.getText(), txtPassword
								.getText(), txtJdbcUrl.getText(), txtSQL
								.getText(), includeHeader, maskQuote, cbxSeparator
								.getText(), txtDateFormat.getText(),txtNumberFormat.getText(),
								txtScriptFileName.getText(), useStaticFilename,
								fileName);
						
						// store File in output window ...
						txtOutput.setText(FileToString
								.getFileAsString(txtScriptFileName.getText()));
						GuiUtils.hideWaitCursor();

						MessageDialog.openInformation(getShell(),
								"Skript Erstellung", "Success!");
						txtOutput.setFocus();
					} catch (SQLException e) {
						GuiUtils.hideWaitCursor();

						MessageDialog.openError(getShell(), "Error", e
								.getMessage());
					} catch (IOException e) {
						GuiUtils.hideWaitCursor();
						MessageDialog.openError(getShell(), "Error", e
								.getMessage());
					}

				}
			};
			actionGenerateScript.setText("Skript erzeugen");
		}
	}

	protected MenuManager createMenuManager() {
		MenuManager result = new MenuManager("menu");
		{
			final MenuManager menuFile = new MenuManager("Datei");
			result.add(menuFile);
			menuFile.add(actionGenerateScript);
			menuFile.add(new Separator());
			menuFile.add(actionExit);
		}
		return result;
	}

	protected ToolBarManager createToolBarManager(int arg) {
		ToolBarManager toolBarManager = new ToolBarManager(SWT.FLAT | SWT.WRAP);
		return toolBarManager;
	}

	public void run() {
		open();
		Display display = Display.getCurrent();

		Shell shell = getShell();
		shell.setSize(getInitialSize());

		// load properties
		setDefaults(propertiesFilename);

		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public static void main(String args[]) {
		Display display = new Display();
		propertiesFilename = args.length == 0 ? "" : args[0];
		OracleExportTool window = new OracleExportTool();
		window.run();
	}

	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText("Oracle Export Tool");
	}

	protected Point getInitialSize() {
		return new Point(518, 418);
	}
}